/*******************************************************************************

Author : Mauro Laurenti
Version : 1.1

Created on Date : 04/09/2006
Last update     : 25/01/2013

CopyRight 2006-2013 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

*******************************************************************************/


#ifdef __XC8
#include <xc.h>
#endif

#include <delay.h>

unsigned char delay_quartz_frequency_value = 20;


//************************************************************
//             delay_ms function implementation
//************************************************************



void delay_ms (int value_ms) {
	
	unsigned int reference = 0;
	unsigned int mainDelay;
	unsigned int subDelay;	
	
	reference = value_ms * delay_quartz_frequency_value;
	
	for (mainDelay = 0; mainDelay < reference; mainDelay++) {

		#ifndef __XC8
                    for (subDelay = 0; subDelay < 6; subDelay++);
                #endif

                #ifdef __XC8
                    #ifdef _PIC18
                        for (subDelay = 0; subDelay < 9; subDelay++);
                    #else
                        for (subDelay = 0; subDelay < 6; subDelay++);
                    #endif            
                #endif
	}	
}

//************************************************************
//             delay_s function implementation
//************************************************************

void delay_s (unsigned char value_s) {

	unsigned char repeat_loop;

	for (repeat_loop = 0; repeat_loop < value_s; repeat_loop++)
		delay_ms (1000);
}


//************************************************************
//             setQuartz function implementation
//************************************************************

void setQuartz (unsigned char frequency) {

	delay_quartz_frequency_value = frequency;
	
} 

